unit rloop_main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  Menus, StdCtrls, Buttons,
  Math;

type

  { TWdMain }

  TWdMain = class(TForm)
    CbxAc: TComboBox;
    CbxFAc: TComboBox;
    CBxDiamFil: TComboBox;
    CbxEp: TComboBox;
    CbxHa: TComboBox;
    CbxLa: TComboBox;
    CbxEc: TComboBox;
    CbxNbSp: TComboBox;
    EdCaccord: TEdit;
    EdFaccord: TEdit;
    EdDiamFil: TEdit;
    EdEpaisseur: TEdit;
    EdHauteur: TEdit;
    EdCaccord2: TEdit;
    EdCcadre: TEdit;
    EdEquCirc: TEdit;
    EdLargeur: TEdit;
    EdNbSpires: TEdit;
    EdRrayonnement: TEdit;
    EdRpeau: TEdit;
    EdRfil: TEdit;
    EdLcadre: TEdit;
    EdLfil: TEdit;
    EdRPertes: TEdit;
    EdLtotale: TEdit;
    EdCtotale: TEdit;
    Gr09: TGroupBox;
    Gr01: TGroupBox;
    Gr06: TGroupBox;
    Gr02: TGroupBox;
    Gr03: TGroupBox;
    Image1: TImage;
    Label1: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label2: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    MainMenu1: TMainMenu;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem4: TMenuItem;
    MenuItem5: TMenuItem;
    MenuItem6: TMenuItem;
    MenuItem7: TMenuItem;
    Pa0: TPanel;
    PaAntenne: TPanel;
    PaEc: TPanel;
    PaRendement: TPanel;
    PaUinduite: TPanel;
    PaFacteurQ: TPanel;
    PaBp: TPanel;
    PaLambda: TPanel;
    PaPrcLambda: TPanel;
    PaFrRes: TPanel;
    PaUfr: TPanel;
    PaUfq: TPanel;
    PaUbp: TPanel;
    PaUac: TPanel;
    PaUra: TPanel;
    PaPrc: TPanel;
    PaUrp: TPanel;
    PaUre: TPanel;
    PaUvi: TPanel;
    PaUlm: TPanel;
    PaUrf: TPanel;
    PaUlc: TPanel;
    PaUlf: TPanel;
    PaUrt: TPanel;
    PaUlt: TPanel;
    PaUct: TPanel;
    PaUcc: TPanel;
    PaUsf: TPanel;
    PaUsc: TPanel;
    PaLongueurFil: TPanel;
    Panel1: TPanel;
    Panel10: TPanel;
    Panel11: TPanel;
    Panel12: TPanel;
    Panel13: TPanel;
    Panel14: TPanel;
    Panel15: TPanel;
    Panel16: TPanel;
    Panel17: TPanel;
    Panel18: TPanel;
    Panel19: TPanel;
    Panel2: TPanel;
    Panel20: TPanel;
    PaUlgf: TPanel;
    PaVf: TPanel;
    PaSectionFil: TPanel;
    PaSurfaceCadre: TPanel;
    PaVp: TPanel;
    PaS1: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    Panel6: TPanel;
    Panel7: TPanel;
    Panel8: TPanel;
    Panel9: TPanel;
    SpeedButton1: TSpeedButton;
    procedure CbxAcChange(Sender: TObject);
    procedure CBxDiamFilChange(Sender: TObject);
    procedure CbxEpChange(Sender: TObject);
    procedure CbxHaChange(Sender: TObject);
    procedure CbxEcChange(Sender: TObject);
    procedure CbxLaChange(Sender: TObject);
    procedure EdCtotaleChange(Sender: TObject);
    procedure EdDiamFilChange(Sender: TObject);
    procedure EdCaccordChange(Sender: TObject);
    procedure EdEpaisseurChange(Sender: TObject);
    procedure EdEquCircChange(Sender: TObject);
    procedure EdFaccordChange(Sender: TObject);
    procedure EdHauteurChange(Sender: TObject);
    procedure EdLargeurChange(Sender: TObject);
    procedure EdNbSpiresChange(Sender: TObject);
    procedure EdRPertesChange(Sender: TObject);
    procedure EdRrayonnementChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Gr06Click(Sender: TObject);
    procedure Gr09Click(Sender: TObject);
    procedure Label2Click(Sender: TObject);
    procedure MenuItem2Click(Sender: TObject);
    procedure MenuItem3Click(Sender: TObject);
    procedure MenuItem4Click(Sender: TObject);
    procedure MenuItem5Click(Sender: TObject);
    procedure MenuItem6Click(Sender: TObject);
    procedure MenuItem7Click(Sender: TObject);
    procedure MenuItem8Click(Sender: TObject);
    procedure PaLambdaClick(Sender: TObject);
    procedure PaPrcClick(Sender: TObject);
    procedure PaS1Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
    function If_Chiffre(s: string): boolean;
    function RealToStr(Reel: real; Decimal: byte): string;
    function StrToReal(Chaine: string): real;
    function Saisie_Chiffres(s: string): string;
  end;

var
  WdMain: TWdMain;
  DirExe: string;

implementation

Uses rloop_formulaire, rloop_resonnance;

{$R *.lfm}

{ TWdMain }

const
  //Sauvegarde
  SauveData_ = 'Rloop.dat';
  SauveDataTexte = 'Rloop.txt';
  //Constante dielectrique du vide
  Epsilon0 = 8.8542 * 1E-12; //A -s/V m
  //Résistivité du cuivre, en Ohm.m
  Rho = 16.78 * 1E-9;
  //Perméabilité magnétique du vide
  Mu0 = 4 * PI * 1E-7; //0.0000012566370614359172953850573533118 H/m;
  //Perméabilité magnétique de l'air
  MuR = 1.0000004;
  //Célérité de la lumière dans le vide
  //CeleriteLumiere=3*1E8;
  CeleriteLumiere = 1 / Sqrt(Mu0 * Epsilon0);//3^8 m/s
  //Z0-Ipédance caractéristique du vide
  //Z0=Mu0 * CeleriteLummiere;
  //Pour le calcul du rayonnement
  //(mais formule développée, et ne l'utilise pas)
  Z0 = Sqrt(Mu0 / Epsilon0); //Z0=376.7 ohms

type
  Valeurs_ = record
    //largeur
    La: string[20];
    CbLa: integer;
    //Hauteur
    Ha: string[20];
    CbHa: integer;
    //Diametre Fil
    Di: string[20];
    CbDi: integer;
    //Epaisseur
    Ep: string[20];
    CbEp: integer;
    //-
    //Nb Spires
    Sp: string[20];
    CbSp: integer;
    //-
    //C accord
    Cacc: string[20];
    CbCacc: integer;
    //-
    //Frequence accord
    Facc: string[20];
    CbFacc: integer;
  end;

var
  Valeurs: Valeurs_;
  //-
  //----- Valeurs physiques -----
  //-
  //Largeur, Hauteur, Diamètre
  RLargeur, RHauteur, RDiametreFil: real;
  //Nb Spires, Epaisseur
  RNbSpires, REpaisseur: real;
  //-
  //----- Valeurs calculés -----
  //-
  //Longueurs,
  RLongueurFil: real;
  //Surfaces
  RSectionFil, RSurfaceCadre: real;
  //-
  //----- Valeurs électromagnétiques -----
  //-
  //Fréquence de Résonnance
  RFrequenceResonnance: real;
  RLambdaAccord, RLambdaPrc: real;
  //-
  //----- Valeurs électroniques -----
  //-
  //Facteur de Qualité, Bp, Rendement
  RFacteurDeQualite, RBandePassante, RRendement: real;
  //Tension Induite
  RTensionInduite: real;
  //Inductance du Fil, du Cadre et Totale
  RInductanceFil, RInductanceCadre: real;
  RInductanceTotale: real;
  //Capacite Accord, du Cadre, Totale
  RCapaciteAccord: real;
  RCapaciteCadre, RCapaciteTotale: real;
  //Resistance de Rayonnement, du Fil, de Peau et Totale
  RResistanceRayonnement, RResistanceFil: real;
  RResistancePeau, RResistancePertes: real;
  //Fréquence d'accord
  RFrequenceAccord: real;
  //Divers
  //Equivalence circulaire
  RequDiam: real;
  //R Rayonnement
  RHrms: real;

function TWdMain.RealToStr(Reel: real; Decimal: byte): string;
var
  s: string;
begin
  Str(Reel: 0: Decimal, s); //avec 2 décimales
  Result := s;
end;

function TWdMain.StrToReal(Chaine: string): real;
var
  r: real;
  Pos: integer;
begin
  Val(Chaine, r, Pos);
  if Pos > 0 then
    Val(Copy(Chaine, 1, Pos - 1), r, Pos);
  Result := r;
end;

function Convert_en_Point(s: string): string;
var
  t: string;
  n: integer;
begin
  t := s;
  if t <> '' then
  begin
    for n := 1 to Length(t) do
      if t[n] = ',' then
        t[n] := '.';
  end;
  Result := t;
end;

function TWdMain.If_Chiffre(s: string): boolean;
var
  Chiffres, Virgules: integer;
  Lg, n: integer;
  Ok: boolean;
begin
  Ok := False;
  Lg := Length(s);
  if Lg = 0 then
    Ok := True
  else
  begin
    Chiffres := 0;
    Virgules := 0;
    for n := 1 to Length(s) do
    begin
      if s[n] in ['0'..'9'] then
        Inc(Chiffres);
      if s[n] = '.' then
        Inc(Virgules);
    end;
    if (Chiffres = Lg) or ((Chiffres = Lg - 1) and (Virgules = 1)) then
      Ok := True;
  end;
  Result := Ok;
end;

function Lambda(F: real): real;
var
  Lba: real;
begin
  Lba := 0;
  if F <> 0 then
    Lba := CeleriteLumiere / F;
  Result := Lba;
end;

//----- CALCUL de BASE ----------------------------------
function R_Section_Fil(Diametre: real): real;
begin
  // S Circulaire = Pi * R² = PI * (D/2)²
  if Diametre > 0 then
    Result := PI * Power(Diametre, 2) / 4
  else
    Result := 0;
end;

function R_Longueur_Fil(Largeur, Hauteur, Spires: real): real;
begin
  //Longueur Totale Fil = L * H * N
  Result := ((Largeur * 2) + (Hauteur * 2)) * Spires;
end;

function R_Surface_Cadre(Largeur, Hauteur: real): real;
begin
  //S Spire = L * H
  Result := Largeur * Hauteur;
end;

//----- CALCUL CADRE RECTANGULAIRE-----------------------
function R_Inductance_Fil(Largeur, Hauteur, Spires, DiametreFil: real): real;
var
  L, L2, L3, L4, LongTotalFil: real;
begin
  LongTotalFil := R_Longueur_Fil(Largeur, Hauteur, Spires);
  L := 2 * 1E-7 * LongTotalFil;
  if (LongTotalFil > 0) and (DiametreFil > 0) then
    L2 := 2.303 * Log10((4 * LongTotalFil) / DiametreFil)
  else
    L2 := 0;
  L3 := 0.75;
  if (DiametreFil > 0) and (LongTotalFil > 0) then
    L4 := DiametreFil / (2 * LongTotalFil)
  else
    L4 := 0;
  L := L * (L2 - L3 + L4);
  Result := L;
end;

function R_Inductance_Cadre(Nspires, Largeur, Epaisseur: real): real;
var
  L, Lh, Lb, L1, L2, L3: real;
begin
  //L= 8 * ^-7 * N² * Larg( Ln(1,4142 * Larg * Nsp / (N + 1) * Epaisseur )
  //  + 0,37942 + ( 0,3333 (N +1 ) * Epaisseur ) / ( Larg * N )
  L := 8 * 1E-7 * Power(Nspires, 2) * Largeur; //0,0012
  Lh := 1.4142 * Largeur * Nspires;
  Lb := (Nspires + 1) * Epaisseur;
  if (Lh > 0) and (Lb > 0) then
    L1 := Lh / (Lb)
  else
    L1 := 0;
  //-
  L2 := 0.37942;
  //-
  Lh := 0.3333 * (Nspires + 1) * Epaisseur;
  Lb := Largeur * Nspires;
  if (Lh > 0) and (Lb > 0) then
    L3 := Lh / (Lb)
  else
    L3 := 0;
  //-
  L := L * Ln(L1 + L2 + L3);
  Result := L;
end;

function R_Resistance_Rayonnement(NbSpires, Largeur, Hauteur, Frequence: real): real;
var
  R, R2, R3, SurfaceSpire: real;
begin
  //Rr = (32 * PiE4 * 1E-7) * / ( 3 * CeléritéE3 ) * ( Mur * N * Sspires * ) ² F4
  //Z0 = 4 Pi 1E-7
  SurfaceSpire := Largeur * Hauteur;
  R2 := (32 * Power(Pi, 4) * 1E-7) / (3 * Power(CeleriteLumiere, 3));
  R3 := Power(MuR * NbSpires * SurfaceSpire, 2) * Power(Frequence, 4);
  R := R2 * R3;
  Result := R;
end;

function R_Resistance_Fil(LongueurFil, RDiametreFil: real): real;
var
  R, R2: real;
begin
  R2 := (Pi * RDiametreFil * RDiametreFil) / 4;
  if RDiametreFil > 0 then
    R := (LongueurFil * Rho) / R2
  else
    R := 0;
  Result := R;
end;

function R_Resistance_Peau(LongueurFil, DiametreFil, FrequenceAccord: real): real;
var
  R, R2: real;
begin
  if (LongueurFil > 0) and (DiametreFil > 0) then
  begin
    //R:=( LongTotalFil / (Pi * d ) ) * Sqrt( Pi * Mu0 * f * Rho );
    R := LongueurFil / (Pi * DiametreFil);
    R2 := Sqrt(Pi * Mu0 * FrequenceAccord * Rho);
    R := R * R2;
  end
  else
    R := 0;
  Result := R;
end;

function R_Capacite_distribuee_du_Cadre(Largeur, Epaisseur: real): real;
var
  C, C2, C3, Cr: real;
begin
  //Capacité distribuée du cadre
  if Largeur > 0 then
    C2 := Power((400 * Largeur) / Pi, 4)
  else
    C2 := 0;
  C3 := 100 * Epaisseur;
  if (C2 > 0) and (C3 > 0) then
  begin
    Cr := C2 / C3;
    C := 3.9685 * 1E-13 * Power(Cr, 0.333);
  end
  else
  begin
    C := 0;
  end;
  Result := C;
end;

function R_Facteur_de_Qualite(Frequence, Ltotale, Rtotale: real): real;
var
  Q, Q2: real;
begin
  Q := 2 * Pi * Frequence;
  if Rtotale > 0 then
    Q2 := Ltotale / Rtotale
  else
    Q2 := 0;
  Q := Q * Q2;
  Result := Q;
end;

function R_Frequence_de_Resonnance(L, C: real): real;
begin
  if (L > 0) and (C > 0) then
    Result := 1 / (2 * Pi * Sqrt(L * C))
  else
    Result := 0;
end;

function R_Bande_Passante(FrequencedeResonnance, FacteurdeQualite: real): real;
begin
  //Bande passante à -3 dB
  if FacteurdeQualite > 0 then
    Result := FrequencedeResonnance / FacteurdeQualite
  else
    Result := 0;
end;

function R_Capacite_de_Resonnance(L, Frequence: real): real;
begin
  if (Frequence > 0) and (L > 0) then
    Result := 1 / (4 * Pi * Pi * Power(Frequence, 2) * L)
  else
    Result := 0;
end;

function R_Inductance_de_Resonnance(C, Frequence: real): real;
begin
  if (Frequence > 0) and (C > 0) then
    Result := 1 / (4 * Pi * Pi * Power(Frequence, 2) * C)
  else
    Result := 0;
end;

function R_Rendement(RRayonnement, RFil, RPeau: real): real;
var
  R, Rtotal: real;
begin
  Rtotal := RFil + RPeau;
  if (RRayonnement > 0) and (Rtotal > 0) then
    R := (RRayonnement / (Rtotal)) * 100
  else
    R := 0;
  Result := R;
end;

function R_Tension_Induite(Spires, A, Frequence, Hrms: real): real;
begin
  //Vrms=2 PI Mu0 MuR N A F Hrms Cos(alpha) -> Perpend., Alpha=1
  Result := 2 * Pi * Mu0 * MuR * Spires * A * Frequence * Hrms;
end;

function R__Equivalence_Deux_Largeur(Diametre: real): real;
var
  S, Largeur: real;
begin
  S := PI * Power(Diametre / 2, 2);
  //S = Pi * (D/2)² = La * Lh = Largeur² -> Largeur = Sqrt ( S )
  Largeur := Sqrt(S);
  Result := Largeur;
end;

function TWdMain.Saisie_Chiffres(s: string): string;
var
  t: string;
  n: integer;
  p: boolean;
begin
  t := '';
  if s <> '' then
  begin
    p := False;
    for n := 1 to Length(s) do
    begin
      case s[n] of
        '0'..'9': t := t + s[n];
        '.',',': if not p then
          begin
            t := t + '.';
            p := True;
          end;
      end;
    end;
  end;
  Result := t;
end;

procedure Sauver_Valeurs_Initiales;
var
  Fil: file of Valeurs_;
begin
  //Récupération des données
  with WdMain do
  begin
    with Valeurs do
    begin
      //Largeur
      La := EdLargeur.Text;
      CbLa := CbxLa.ItemIndex;
      //Hauteur
      Ha := EdHauteur.Text;
      CbHa := CbxHa.ItemIndex;
      //Diamètre
      Di := EdDiamFil.Text;
      CbDi := CBxDiamFil.ItemIndex;
      //Epaisseur
      Ep := EdEpaisseur.Text;
      CbEp := CbxEp.ItemIndex;
      //Nb Spires
      Sp := EdNbSpires.Text;
      CbSp := CbxNbSp.ItemIndex;
      //C accord
      Cacc := EdCaccord.Text;
      CbCacc := CbxAc.ItemIndex;
      //Frequence accord
      Facc := EdFaccord.Text;
      CbFacc := CbxFAc.ItemIndex;
    end;
  end;
  AssignFile(Fil, DirExe + Sauvedata_);
{$i-}
  Rewrite(Fil);
{$i+}
  if Ioresult = 0 then
  begin
{$i-}
    Write(Fil, Valeurs);
    if Ioresult <> 0 then
      ShowMessage('   Erreur en écriture des données de "' + SauveData_ + '"   ');
{$i-}
    CloseFile(Fil);
{$i+}
  end
  else
    ShowMessage('   Erreur en création du fichier "' + SauveData_ + '"   ');
  ShowMessage('   Valeurs initiales du cadre sauvegardées.   ');
end;

procedure Lire_Valeurs_Initiales;
var
  Fil: file of Valeurs_;
begin
  AssignFile(Fil, DirExe + Sauvedata_);
 {$i-}
  Reset(Fil);
{$i+}
  if Ioresult = 0 then
  begin
  {$i-}
    Read(Fil, Valeurs);
{$i+}
    if Ioresult = 0 then
      with WdMain do
      begin
        with Valeurs do
        begin
          //Largeur
          EdLargeur.Text := La;
          CbxLa.ItemIndex := CbLa;
          //Hauteur
          EdHauteur.Text := Ha;
          CbxHa.ItemIndex := CbHa;
          //Diamètre, Spires
          EdDiamFil.Text := Di;
          CbxDiamFil.ItemIndex := CbDi;
          //Epaisseur
          EdEpaisseur.Text := Ep;
          CbxEp.ItemIndex := CbEp;
          //Nb Spires
          EdNbSpires.Text := Sp;
          CbxNbSp.ItemIndex := CbSp;
          //Epaisseur
          EdEpaisseur.Text := Ep;
          CbxEp.ItemIndex := CbEp;
          //Capacité d'accord
          EdCaccord.Text := Cacc;
          CbxAc.ItemIndex := CbCacc;
          //Frequence accord
          EdFaccord.Text := Facc;
          CbxFAc.ItemIndex := CbFacc;
        end;
      end
    else
      ShowMessage('   Erreur en lecture de "' + SauveData_ + '"   ');
  {$i-}
    CloseFile(Fil);
{$i+}
  end
  else
    ShowMessage('   Lecture du fichier "' + SauveData_ + '" impossible.   ');
  ShowMessage('   Valeurs initiales du cadre restaurée.   ');
end;

procedure UnPpa(Select: integer; s: string);
begin
  with WdMain do
  begin
    case Select of
      //Longueur fil
      1: PaUlgf.Caption := s;
      //Section fil
      2: PaUsf.Caption := s;
      //Surface cadre
      3: PaUsc.Caption := s;
      //Inductance fil
      4: PaUlf.Caption := s;
      //Inductance cadre
      5: PaUlc.Caption := s;
      //Inductance totale
      6: PaUlt.Caption := s;
      //Capacité accord
      7: PaUac.Caption := s;
      //Capacité cadre
      8: PaUcc.Caption := s;
      //Capacité totale
      9: PaUct.Caption := s;
      //Fréquence de résonnance
      10: PaUfr.Caption := s;
      //Résistance rayonnement
      11: PaUra.Caption := s;
      //Résistance du fil
      12: PaUrf.Caption := s;
      //Résistance de peau
      13: PaUrp.Caption := s;
      //Résistance totale
      14: PaUrt.Caption := s;
      //Lambda
      15: PaUlm.Caption := s;
      //Bande passante
      16: PaUbp.Caption := s;
      //Tension induite
      17: PaUvi.Caption := s;
    end;
  end;
end;

function ItemIndexToInteger(Select: byte): integer;
var
  Idx: integer;
begin
  Idx := -1;
  with WdMain do
  begin
    case Select of
      //----- VARIABLES - 1 à 7 -----
      //Largeur
      1: Idx := CbxLa.ItemIndex;
      //Hauteur
      2: Idx := CbxHa.ItemIndex;
      //Diam. fil
      3: Idx := CbxDiamFil.ItemIndex;
      //Epaisseur
      4: Idx := CbxEp.ItemIndex;
      //Nb Spires
      5: Idx := CbxNbSp.ItemIndex;
      //C Accord
      6: Idx := CbxAc.ItemIndex;
      //F Accord
      7: Idx := CbxFAc.ItemIndex;
      //Equivalence circulaire
      8: Idx := CbxEc.ItemIndex;
    end;
  end;
  Result := Idx;
end;

function Unites_Manuelles(Select: integer; v: real): real;
var
  k: real;
  Idx: integer;
begin
  //Idx=ItemIndex
  Idx := ItemIndexToInteger(Select);
  with WdMain do
  begin
    case Select of
      //Mètre
      1, 2, 3, 4, 8: case Idx of
          0: k := 1E3;   //km
          1: k := 1;       //Mètre
          2: k := 1E-1;  //dm
          3: k := 1E-2;  //cm
          4: k := 1E-3;  //mm
          5: k := 1E-6;  //µm
          6: k := 1E-9;  //nm
          7: k := 1E-12;//pm
        end;
      //Spires
      5:
      begin //Spires
      end;
      //Capacitance
      6: case Idx of
          0: k := 1E3;  //kF
          1: k := 1;      //Farad
          2: k := 1E-3; //mF
          3: k := 1E-6; //µF
          4: k := 1E-9; //nF
          5: k := 1E-12;//pF
          6: k := 1E-15;//fF
        end;
      //Fréquence
      7: case Idx of
          0: k := 1E12; //Thz
          1: k := 1E9;  //Ghz
          2: k := 1E6;  //Mhz
          3: k := 1E3;  //Khz
          4: k := 1;      //Hz
          5: k := 1E-3; //mHz
          6: k := 1E-6; //µHz
          7: k := 1E-9; //nHz
          8: k := 1E-12;//pHz
          9: k := 1E-15;//fHz
        end;
    end;
  end;
  Result := v * k;
end;

function Unites_Auto(Select: integer; v: real): real;
var
  r, k: real;
begin
  r := v;
  k := 1;
  if v = 0 then
  begin
    r := 0;
  end
  else
  begin
    with WdMain do
    begin
      if v >= 1 then
      begin
        if v >= 1E9 then
        begin
          k := 1E-9;
          case Select of
            1: UnPpa(1, 'Gm');
            10: UnPpa(10, 'GHz');
            11: UnPpa(11, 'GΩ');
            12: UnPpa(12, 'GΩ');
            13: UnPpa(13, 'GΩ');
            14: UnPpa(14, 'GΩ');
            16: UnPpa(16, 'GHz');
            17: UnPpa(17, 'GV');
          end;
        end
        else
        begin
          if v >= 1E6 then
          begin
            k := 1E-6;
            case Select of
              1: UnPpa(1, 'Mm');
              10: UnPpa(10, 'MHz');
              11: UnPpa(11, 'MΩ');
              12: UnPpa(12, 'MΩ');
              13: UnPpa(13, 'MΩ');
              14: UnPpa(14, 'MΩ');
              16: UnPpa(16, 'MHz');
              17: UnPpa(17, 'MV');
            end;
          end
          else
          begin
            if v >= 1E3 then
            begin
              k := 1E-3;
              case Select of
                1: UnPpa(1, 'km');
                2: UnPpa(2, '.');
                3:
                begin
                  UnPpa(3, 'm²');
                  k := 1;
                end;
                4: UnPpa(4, 'kH');
                5: UnPpa(5, 'kH');
                6: UnPpa(6, 'kH');
                7: UnPpa(7, 'kF');
                8: UnPpa(8, 'kF');
                9: UnPpa(9, 'kF');
                10: UnPpa(10, 'kHz');
                11: UnPpa(11, 'kΩ');
                12: UnPpa(12, 'kΩ');
                13: UnPpa(13, 'kΩ');
                14: UnPpa(14, 'kΩ');
                15: UnPpa(15, 'km');
                16: UnPpa(16, 'kHz');
                17: UnPpa(17, 'kV');
              end;
            end
            else
            begin
              k := 1;
              case Select of
                1: UnPpa(1, 'm');
                2: UnPpa(2, 'm²');
                3: UnPpa(3, 'm²');
                4: UnPpa(4, 'H');
                5: UnPpa(5, 'H');
                6: UnPpa(6, 'H');
                7: UnPpa(7, 'F');
                8: UnPpa(8, 'F');
                9: UnPpa(9, 'F');
                10: UnPpa(10, 'Hz');
                11: UnPpa(11, 'Ω');
                12: UnPpa(12, 'Ω');
                13: UnPpa(13, 'Ω');
                14: UnPpa(14, 'Ω');
                15: UnPpa(15, 'm');
                16: UnPpa(16, 'Hz');
                17: UnPpa(17, 'V');
              end;
            end;
          end;

        end;
      end
      else
      begin
        if v >= 1E-3 then
        begin
          k := 1E3;
          case Select of
            1: UnPpa(1, 'mm');
            2: UnPpa(2, '.');
            3: UnPpa(3, 'm²');
            4: UnPpa(4, 'mH');
            5: UnPpa(5, 'mH');
            6: UnPpa(6, 'mH');
            7: UnPpa(7, 'mF');
            8: UnPpa(8, 'mF');
            9: UnPpa(9, 'mF');
            10: UnPpa(10, 'mHz');
            11: UnPpa(11, 'mΩ');
            12: UnPpa(12, 'mΩ');
            13: UnPpa(13, 'mΩ');
            14: UnPpa(14, 'mΩ');
            15: UnPpa(15, 'mm');
            16: UnPpa(16, 'mHz');
            17: UnPpa(17, 'mV');
          end;
        end
        else
        begin
          if v >= 1E-6 then
          begin
            k := 1E6;
            case Select of
              1: UnPpa(1, 'µm');
              2: UnPpa(2, 'mm²');
              3: UnPpa(3, 'mm²');
              4: UnPpa(4, 'µH');
              5: UnPpa(5, 'µH');
              6: UnPpa(6, 'µH');
              7: UnPpa(7, 'µF');
              8: UnPpa(8, 'µF');
              9: UnPpa(9, 'µF');
              10: UnPpa(10, 'µHz');
              11: UnPpa(11, 'µΩ');
              12: UnPpa(12, 'µΩ');
              13: UnPpa(13, 'µΩ');
              14: UnPpa(14, 'µΩ');
              15: UnPpa(15, 'µm');
              16: UnPpa(16, 'µHz');
              17: UnPpa(17, 'µV');
            end;
          end
          else
          begin
            if v >= 1E-9 then
            begin
              k := 1E9;
              case Select of
                1: UnPpa(1, 'nm');
                2: UnPpa(2, 'mm²');
                3:
                begin
                  UnPpa(3, 'mm²');
                  k := 1E6;
                end;
                4: UnPpa(4, 'nH');
                5: UnPpa(5, 'nH');
                6: UnPpa(6, 'nH');
                7: UnPpa(7, 'nF');
                8: UnPpa(8, 'nF');
                9: UnPpa(9, 'nF');
                10: UnPpa(10, 'nHz');
                11: UnPpa(11, 'nΩ');
                12: UnPpa(12, 'nΩ');
                13: UnPpa(13, 'nΩ');
                14: UnPpa(14, 'nΩ');
                15: UnPpa(15, 'nm');
                16: UnPpa(16, 'nHz');
                17: UnPpa(17, 'nV');
              end;
            end
            else
            begin
              if v >= 1E-12 then
              begin
                k := 1E12;
                case Select of
                  1: UnPpa(1, 'pm');
                  2: UnPpa(2, 'µm²');
                  3: UnPpa(3, '.');
                  4: UnPpa(4, 'pH');
                  5: UnPpa(5, 'pH');
                  6: UnPpa(6, 'pH');
                  7: UnPpa(7, 'pF');
                  8: UnPpa(8, 'pF');
                  9: UnPpa(9, 'pF');
                  10: UnPpa(10, 'pHz');
                  11: UnPpa(11, 'pΩ');
                  12: UnPpa(12, 'pΩ');
                  13: UnPpa(13, 'pΩ');
                  14: UnPpa(14, 'pΩ');
                  15: UnPpa(15, 'pm');
                  16: UnPpa(16, 'pHz');
                  17: UnPpa(17, 'pV');
                end;
              end
              else
              begin
                if v >= 1E-15 then
                begin
                  k := 1E15;
                  case Select of
                    1: UnPpa(1, 'pm');

                    4: UnPpa(4, 'fH');
                    5: UnPpa(5, 'fH');
                    6: UnPpa(6, 'fH');
                    7: UnPpa(7, 'fF');
                    8: UnPpa(8, 'fF');
                    9: UnPpa(9, 'fF');
                    10: UnPpa(10, 'fHz');
                    11: UnPpa(11, 'fΩ');
                    12: UnPpa(12, 'fΩ');
                    13: UnPpa(13, 'fΩ');
                    14: UnPpa(14, 'fΩ');
                    15: UnPpa(15, 'fm');
                    16: UnPpa(16, 'fHz');
                    17: UnPpa(17, 'fV');
                  end;
                end;
              end;
            end;
          end;
        end;
      end;
    end;
  end;
  Result := r * k;
end;

procedure Saisie_vers_Data(Select: integer);
var
  s: string;
begin
  with WdMain do
  begin
    case Select of
      //Largeur
      1:
      begin
        s := EdLargeur.Text;
        if If_Chiffre(s) then
        begin
          RLargeur := StrToReal(s);
          RLargeur := Unites_Manuelles(Select, RLargeur);
        end;
      end;
      //RLargeur := Convert_dans_Unite_de_Base_des_Variables(1, StrToReal(s));
      //Hauteur
      2:
      begin
        s := EdHauteur.Text;
        if If_Chiffre(s) then
        begin
          RHauteur := StrToReal(s);
          RHauteur := Unites_Manuelles(Select, RHauteur);
        end;
      end;
      //Diametre Fil
      3:
      begin
        s := EdDiamFil.Text;
        if If_Chiffre(s) then
        begin
          RDiametreFil := StrToReal(s);
          RDiametreFil := Unites_Manuelles(Select, RDiametreFil);
        end;
      end;
      //Epaisseur
      4:
      begin
        s := EdEpaisseur.Text;
        if If_Chiffre(s) then
        begin
          REpaisseur := StrToReal(s);
          REpaisseur := Unites_Manuelles(Select, REpaisseur);
        end;
      end;
      //Nb Spires
      5:
      begin
        s := EdNbSpires.Text;
        if If_Chiffre(s) then
        begin
          RNbSpires := StrToReal(s);
        end;
      end;
      //Capacité d'Accord
      6:
      begin
        s := EdCaccord.Text;
        if If_Chiffre(s) then
        begin
          RCapaciteAccord := StrToReal(s);
          RCapaciteAccord := Unites_Manuelles(Select, RCapaciteAccord);
        end;
      end;
      //Fréquence d'accord
      7:
      begin
        s := EdFaccord.Text;
        RFrequenceAccord := StrToReal(s);
        RFrequenceAccord := Unites_Manuelles(Select, RFrequenceAccord);
      end;
      //Equivalence Largeur/Hauteur
      8:
      begin
        s := EdEquCirc.Text;
        RequDiam := StrToReal(s);
        RequDiam := Unites_Manuelles(Select, RequDiam);
      end;
    end;
    Application.ProcessMessages;
  end;
end;

procedure Data_Calcul_et_Affiche;
var
  Af: real;
begin
  with WdMain do
  begin
    //Longueur du Fil Totale
    RLongueurFil := R_Longueur_Fil(RLargeur, RHauteur, RNbSpires);
    //ShowMessage(RealToStr(RLongueurFil,6));
    Af := Unites_Auto(1, RLongueurFil);
    PaLongueurFil.Caption := ' ' + RealToStr(Af, 3);
    //Section du Fil
    RSectionFil := R_Section_Fil(RDiametreFil);
    Af := Unites_Auto(2, RSectionFil);
    PaSectionFil.Caption := ' ' + RealToStr(Af, 6);
    //Surfaces cadre
    RSurfaceCadre := R_Surface_Cadre(RLargeur, RHauteur);
    //ShowMessage(RealToStr(RSurfaceCadre,9));
    Af := Unites_Auto(3, RSurfaceCadre);
    PaSurfaceCadre.Caption := RealToStr(Af, 6);
    //-
    //----- Inductance -----
    //-
    //Inductances du fil
    RInductanceFil := R_Inductance_Fil(RLargeur, RHauteur, RNbSpires, RDiametreFil);
    Af := Unites_Auto(4, RInductanceFil);
    EdLfil.Caption := RealToStr(Af, 3);
    //Inductance du cadre
    RInductanceCadre := R_Inductance_Cadre(RNbspires, RLargeur, REpaisseur);
    //ShowMessage(RealToStr(RInductanceCadre,6));
    Af := Unites_Auto(5, RInductanceCadre);
    EdLcadre.Caption := RealToStr(Af, 3);
    //Inductance totale
    RInductanceTotale := RInductanceFil + RInductanceCadre;
    Af := Unites_Auto(6, RInductanceTotale);
    EdLTotale.Caption := RealToStr(Af, 3);
    //-
    //----- Capacitance -----
    //-
    //Capacité d'Accord = définie par l'utilisateur, défaut:=1 fF
    Af := Unites_Auto(7, RCapaciteAccord);
    EdCaccord2.Caption := RealToStr(Af, 3);
    //Capacité distribuée du cadre en µF
    RCapaciteCadre := R_Capacite_distribuee_du_Cadre(RLargeur, REpaisseur);
    Af := Unites_Auto(8, RCapaciteCadre);
    EdCcadre.Text := RealToStr(Af, 3);
    //Capacité totale
    RCapaciteTotale := RCapaciteCadre + RCapaciteAccord;
    Af := Unites_Auto(9, RCapaciteTotale);
    EdCtotale.Caption := RealToStr(Af, 3);
    //-
    //----- Fréquence de résonnance -----
    //-
    RFrequenceResonnance := R_Frequence_de_Resonnance(RInductanceTotale,
      RCapaciteTotale);
    Af := Unites_Auto(10, RFrequenceResonnance);
    PaFrRes.Caption := ' ' + RealToStr(Af, 3);
    //-
    //FrAccord:=RFrequenceResonnance;
    //Fr. accord = 10 Khz
    //-
    //-
    //----- Résistance -----
    //-
    //R Rayonnement
    RResistanceRayonnement := R_Resistance_Rayonnement(RNbspires,
      RLargeur, RHauteur, RFrequenceAccord);
    Af := Unites_Auto(11, RResistanceRayonnement);
    EdRrayonnement.Text := RealToStr(Af, 3);
    //R fil
    RResistanceFil := R_Resistance_Fil(RLongueurFil, RDiametreFil);
    Af := Unites_Auto(12, RResistanceFil);
    EdRfil.Text := RealToStr(Af, 3);
    //R peau
    RResistancePeau := R_Resistance_Peau(RLongueurFil, RDiametreFil, RFrequenceAccord);
    //ShowMessage(RealToStr(RResistancePeau,6));
    Af := Unites_Auto(13, RResistancePeau);
    EdRpeau.Text := RealToStr(Af, 3);
    //R totale
    RResistancePertes := RResistanceRayonnement + RResistanceFil + RResistancePeau;
    Af := Unites_Auto(14, RResistancePertes);
    EdRPertes.Text := RealToStr(Af, 3);
    //-
    //Lambda accord
    RLambdaAccord := Lambda(RFrequenceAccord);
    Af := Unites_Auto(15, RLambdaAccord);
    PaLambda.Caption := RealToStr(Af, 3);
    //% Lambda
    if RLambdaAccord <> 0 then
      RLambdaPrc := (RLongueurFil * 100) / (RLambdaAccord / 4)
    else
      RLambdaPrc := 0;
    PaPrcLambda.Caption := ' ' + RealToStr(RLambdaPrc, 3);
    //-
    //Facteur de Qualité
    RFacteurDeQualite := R_Facteur_de_Qualite(RFrequenceAccord,
      RInductanceTotale, RResistancePertes);
    PaFacteurQ.Caption := ' ' + RealToStr(RFacteurDeQualite, 3);
    //Bande Passante
    RBandePassante := R_Bande_Passante(RFrequenceAccord, RFacteurdeQualite);
    Af := Unites_Auto(16, RBandePassante);
    PaBp.Caption := ' ' + RealToStr(Af, 3);
    //Rendement
    RRendement := R_Rendement(RResistanceRayonnement, RResistanceFil, RResistancePeau);
    PaRendement.Caption := ' ' + RealToStr(RRendement, 3);
    //TensionInduite
    RHrms := 1;
    RTensionInduite := R_Tension_Induite(RNbSpires, RSurfaceCadre,
      RFrequenceAccord, RHrms);
    Af := Unites_Auto(17, RTensionInduite);
    PaUinduite.Caption := ' ' + RealToStr(Af, 3);
  end;
end;

procedure Equivalence_LH;
var
  SurfaceCirculaire: real;
begin
  with WdMain do
  begin
    //ShowMessage(realToStr(RequDiam,6));
    SurfaceCirculaire := Pi * Power(RequDiam / 2, 2);
    CbxLa.ItemIndex := 1;
    EdLargeur.Caption := RealToStr(Sqrt(SurfaceCirculaire), 3);
    CbxHa.ItemIndex := 1;
    EdHauteur.Caption := EdLargeur.Caption;
  end;
end;

procedure Data_Init;
var
  n: integer;
begin
  for n := 1 to 7 do
    Saisie_vers_Data(n);
  Data_Calcul_et_Affiche;
end;

procedure TWdMain.MenuItem2Click(Sender: TObject);
begin
  WdMain.Close;
end;

procedure TWdMain.MenuItem3Click(Sender: TObject);
begin
  //Résonnance
  WdResonnance.Show;
end;

procedure TWdMain.MenuItem4Click(Sender: TObject);
begin
  WdFormulaire.Show;
end;

procedure TWdMain.MenuItem5Click(Sender: TObject);
begin
  //Sauver sous
end;

procedure TWdMain.MenuItem6Click(Sender: TObject);
begin
  Lire_Valeurs_Initiales;
  Data_Init;
end;

procedure TWdMain.MenuItem7Click(Sender: TObject);
begin
  Sauver_Valeurs_Initiales;
end;

procedure TWdMain.MenuItem8Click(Sender: TObject);
begin


end;

procedure TWdMain.PaLambdaClick(Sender: TObject);
begin

end;

procedure TWdMain.PaPrcClick(Sender: TObject);
begin

end;

procedure TWdMain.PaS1Click(Sender: TObject);
begin

end;

procedure TWdMain.SpeedButton1Click(Sender: TObject);
begin
  Equivalence_LH;
end;

procedure TWdMain.EdDiamFilChange(Sender: TObject);
begin
  EdDiamFil.Text := Saisie_Chiffres(EdDiamFil.Text);
  EdDiamFil.SelStart := Length(EdDiamFil.Text);
  Saisie_vers_Data(3);
  Data_Calcul_et_Affiche;
end;

procedure TWdMain.CbxLaChange(Sender: TObject);
begin
  Saisie_vers_Data(1);
  Data_Calcul_et_Affiche;
end;

procedure TWdMain.EdCtotaleChange(Sender: TObject);
begin

end;

procedure TWdMain.CbxHaChange(Sender: TObject);
begin
  Saisie_vers_Data(2);
  Data_Calcul_et_Affiche;
end;

procedure TWdMain.CbxEcChange(Sender: TObject);
begin
  Saisie_vers_Data(8);
  Data_Calcul_et_Affiche;
end;

procedure TWdMain.CBxDiamFilChange(Sender: TObject);
begin
  Saisie_vers_Data(3);
  Data_Calcul_et_Affiche;
end;

procedure TWdMain.CbxAcChange(Sender: TObject);
begin
  Saisie_vers_Data(6);
  Data_Calcul_et_Affiche;
end;

procedure TWdMain.CbxEpChange(Sender: TObject);
begin
  Saisie_vers_Data(4);
  Data_Calcul_et_Affiche;
end;

procedure TWdMain.EdCaccordChange(Sender: TObject);
begin
  EdCaccord.Text := Saisie_Chiffres(EdCaccord.Text);
  EdCaccord.SelStart := Length(EdCaccord.Text);
  Saisie_vers_Data(6);
  Data_Calcul_et_Affiche;
end;

procedure TWdMain.EdEpaisseurChange(Sender: TObject);
begin
  EdEpaisseur.Text := Saisie_Chiffres(EdEpaisseur.Text);
  EdEpaisseur.SelStart := Length(EdEpaisseur.Text);
  Saisie_vers_Data(4);
  Data_Calcul_et_Affiche;
end;

procedure TWdMain.EdEquCircChange(Sender: TObject);
begin
  EdEquCirc.Text := Saisie_Chiffres(EdEquCirc.Text);
  EdEquCirc.SelStart := Length(EdEquCirc.Text);
  Saisie_vers_Data(8);
  Data_Calcul_et_Affiche;
end;

procedure TWdMain.EdFaccordChange(Sender: TObject);
begin
  EdFaccord.Text := Saisie_Chiffres(EdFaccord.Text);
  EdFaccord.SelStart := Length(EdFaccord.Text);
  Saisie_vers_Data(7);
  Data_Calcul_et_Affiche;
end;

procedure TWdMain.EdHauteurChange(Sender: TObject);
begin
  EdHauteur.Text := Saisie_Chiffres(EdHauteur.Text);
  EdHauteur.SelStart := Length(EdHauteur.Text);
  Saisie_vers_Data(2);
  Data_Calcul_et_Affiche;
end;

procedure TWdMain.EdLargeurChange(Sender: TObject);
begin
  EdLargeur.Text := Saisie_Chiffres(EdLargeur.Text);
  EdLargeur.SelStart := Length(EdLargeur.Text);
  Saisie_vers_Data(1);
  Data_Calcul_et_Affiche;
end;

procedure TWdMain.EdNbSpiresChange(Sender: TObject);
begin
  EdNbSpires.Text := Saisie_Chiffres(EdNbSpires.Text);
  EdNbSpires.SelStart := Length(EdNbSpires.Text);
  Saisie_vers_Data(5);
  Data_Calcul_et_Affiche;
end;

procedure TWdMain.EdRPertesChange(Sender: TObject);
begin

end;

procedure TWdMain.EdRrayonnementChange(Sender: TObject);
begin

end;

procedure TWdMain.FormShow(Sender: TObject);
begin
  WdMain.Width := 1150;
  WdMain.Height := 472;
  Data_Init;
  ActiveControl := EdLargeur;
end;

procedure TWdMain.Gr06Click(Sender: TObject);
begin

end;

procedure TWdMain.Gr09Click(Sender: TObject);
begin

end;

procedure TWdMain.Label2Click(Sender: TObject);
begin

end;

end.
//0.001 * 0.001 = 1 mm² = 0,000001 = 1E-6//Hauteur//  EdHauteur = EdEquCirc, CbxHa = ComboBox1, Ha//Largeur//  EdLargeur = Edit2, La//Diametre//  EdDiamFil = Edit4, CbxDiamFil = ComboBox4, Di//-//Frequence accord//  EdFa = Edit6, CbxFa = ComboBox6//Nb Spires//  EdNbSpires = Edit5, CbxSp = ComboBox5//Epaisseur//  Edit3 = EdEpaisseur, CbxEp = ComboBox3//-//C Accord//  Edit20 = EdCaccord2, ComboBox7 = CbxCac2//C Cadre//  = EdCcadre, = CbxCa//-//Longueur de fil//EdLongueurFil = ,  CbxLF = ComboBox8//Section du fil
